- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Exponent::Vst::CVstWindow Class Reference

Inheritance diagram for Exponent::Vst::CVstWindow:

List of all members.

## Detailed Description

A VST specific window class.

Date:
  22/04/2005

Author:
  Paul Chana

Version:
  1.0.0 Initial version

  1.0.1 Added Keyoard hook through root

  1.0.2 Converted to VST 2.4 compatiblity

Note:
  All contents of this source code are copyright 2005 Exp Digital Uk.
  This source file is covered by the licence conditions of the Infinity API. You should have recieved a copy
  with the source code. If you didnt, please refer to http://www.expdigital.co.uk All content is the Intellectual property of Exp Digital Uk.
  Certain sections of this code may come from other sources. They are credited where applicable.
  If you have comments, suggestions or bug reports please visit http://support.expdigital.co.uk Please note that VST is copyright Steinberg Media GmBh. No challenge is made to any of their trademarks To use this file, you require a copy of the VST SDK, available from www.steinberg.net for free

Id
  CVstWindow.hpp,v 1.6 2007/02/27 19:47:38 paul Exp

Definition at line 52 of file CVstWindow.hpp.

## Public Member Functions

- void blockUpdates (const bool block)
- virtual void close ()
- CVstWindow (AudioEffect *theEffect, const CRect &windowArea, CWindowAttributes *attributes)
- virtual bool getRect (ERect **rect)
- virtual void handleActionEvent (const CActionEvent &event)
- virtual bool handleKeyDown (const CKeyboardEvent &event)
- virtual bool handleKeyUp (const CKeyboardEvent &event)
- virtual void idle ()
- virtual bool open (void *windowHandle)
- virtual void parameterIsBeingSetFromEditor (const bool setFromEditor=true)
- virtual bool parameterSetFromEditor () const
- virtual void redrawWindow ()
- virtual void redrawWindow (const CRect &area)
- virtual void setParameter (const long index, const double value)
- virtual void startVSTWindow ()
- virtual void update ()
- virtual ~CVstWindow ()

## Protected Member Functions

- virtual void createVSTWindow (void *windowHandle)
- virtual void destroyVSTWindow ()

## Protected Attributes

- bool m_blockUpdates
- ERect m_myRect
- bool m_setFromEditor
- CParentWindow * m_theVSTParentWindow

## Classes

- class CParentWindow
    Inner clas that represents a parent window. More...

## Constructor & Destructor Documentation

Exponent::Vst::CVstWindow::CVstWindow | ( | AudioEffect * | theEffect,
|  | const CRect & | windowArea,
|  | CWindowAttributes * | attributes |
| ) |  |  |

Construction

Parameters:

  | theEffect | The effect tied to this editor
  | windowArea | Size of the editor
  | attributes | Attributes of the window

virtual Exponent::Vst::CVstWindow::~CVstWindow | ( |  | ) | `[virtual]`

Destruction

## Member Function Documentation

void Exponent::Vst::CVstWindow::blockUpdates | ( | const bool | block | ) | `[inline]`

Block updates

Parameters:

  | block | If true all drawing updates are prevented from happening, if false, drawing is allowed as normal

Definition at line 101 of file CVstWindow.hpp.

References m_blockUpdates.

virtual void Exponent::Vst::CVstWindow::close | ( |  | ) | `[virtual]`

Close the window

virtual void Exponent::Vst::CVstWindow::createVSTWindow | ( | void * | windowHandle | ) | `[protected, virtual]`

Create the vst window

Parameters:

  | windowHandle | Parent window handle

virtual void Exponent::Vst::CVstWindow::destroyVSTWindow | ( |  | ) | `[protected, virtual]`

Destroy the vst window

virtual bool Exponent::Vst::CVstWindow::getRect | ( | ERect ** | rect | ) | `[virtual]`

Get the area of the window

Parameters:

  | rect | The rectangle to fill

Return values:

  | bool | 1 On scuess, 0 otherwise..

virtual void Exponent::Vst::CVstWindow::handleActionEvent | ( | const CActionEvent & | event | ) | `[virtual]`

Handle action events

Parameters:

  | event | The action event to handle

virtual bool Exponent::Vst::CVstWindow::handleKeyDown | ( | const CKeyboardEvent & | event | ) | `[virtual]`

Handle key down events

Parameters:

  | event | The event to handle

Return values:

  | bool | TRue if handled, false otherwise

virtual bool Exponent::Vst::CVstWindow::handleKeyUp | ( | const CKeyboardEvent & | event | ) | `[virtual]`

Handle key up events

Parameters:

  | event | The event to handle

Return values:

  | bool | TRue if handled, false otherwise

virtual void Exponent::Vst::CVstWindow::idle | ( |  | ) | `[virtual]`

Silly VST Idle function

virtual bool Exponent::Vst::CVstWindow::open | ( | void * | windowHandle | ) | `[virtual]`

Open the window -> You should override and then call startVSTWindow

Parameters:

  | windowHandle | Parent window handle

Return values:

  | bool | True if opened properly, false otherwise

virtual void Exponent::Vst::CVstWindow::parameterIsBeingSetFromEditor | ( | const bool | setFromEditor = `true` | ) | `[inline, virtual]`

Parameter is being set from the editor

Parameters:

  | setFromEditor | If true user has adjusted on screen control, if false the change is programmatic and the GUI should be redrawn

Definition at line 170 of file CVstWindow.hpp.

References m_setFromEditor.

virtual bool Exponent::Vst::CVstWindow::parameterSetFromEditor | ( |  | ) | const`[inline, virtual]`

Parameter is set from the editor

Return values:

  | bool | If true user has adjusted on screen control, if false the change is programmatic and the GUI should be redrawn

Definition at line 164 of file CVstWindow.hpp.

References m_setFromEditor.

virtual void Exponent::Vst::CVstWindow::redrawWindow | ( |  | ) | `[virtual]`

Set the whole window dirty - generally use sparingly!!

Reimplemented from Exponent::GUI::Windowing::CWindow.

virtual void Exponent::Vst::CVstWindow::redrawWindow | ( | const CRect & | area | ) | `[virtual]`

Set an area of the window dirty

Parameters:

  | area | The area to redraw

Reimplemented from Exponent::GUI::Windowing::CWindow.

virtual void Exponent::Vst::CVstWindow::setParameter | ( | const long | index,
|  | const double | value |
| ) |  |  | `[virtual]`

Set parameter

Parameters:

  | index | The index of the parameter to set
  | value | The value of the parameter to set

virtual void Exponent::Vst::CVstWindow::startVSTWindow | ( |  | ) | `[virtual]`

Start (initialise) the VSTWindow

See also:
  open

virtual void Exponent::Vst::CVstWindow::update | ( |  | ) | `[virtual]`

Update the window

## Member Data Documentation

bool Exponent::Vst::CVstWindow::m_blockUpdates`[protected]`

Should we allow updates?

Definition at line 329 of file CVstWindow.hpp.

Referenced by blockUpdates().

ERect Exponent::Vst::CVstWindow::m_myRect`[protected]`

Stupid VST rect that is required

Definition at line 330 of file CVstWindow.hpp.

bool Exponent::Vst::CVstWindow::m_setFromEditor`[protected]`

Is the change from the editor?

Definition at line 328 of file CVstWindow.hpp.

Referenced by parameterIsBeingSetFromEditor(), and parameterSetFromEditor().

CParentWindow* Exponent::Vst::CVstWindow::m_theVSTParentWindow`[protected]`

The parent window handle

Definition at line 327 of file CVstWindow.hpp.